/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   PAD.cpp
 * Author: Maxi
 * 
 * Created on 12. November 2018, 15:10
 */

#include "PAD.h"

PAD::PAD() {
    iNumPotentialSat=0;
}

PAD::PAD(const PAD& orig) {
}

PAD::~PAD() {
}

void PAD::writeInCsv(std::ofstream &streamData,int &iType)
{
    //helping variables
    int i=0;
    int j=0;
    //int iSizeVec=0;
    //int iNumSatellites=0;
    //int iArrayMaxSatellites[4]={MaxSatellitesGPS, MaxSatellitesEGNOS, MaxSatellitesGLONASS, MaxSatellitesGALILEO};
    //int iArrayAmountSat[4]={iAmountGPS,iAmountEGNOS,iAmountGLO,iAmountGAL};
    //int iMemory=0;
    
    //writing the data in the file
    //std::cout<<"PAD write"<<std::endl;
    streamData<<(int)this->id<<";";//tranform because they are unsigned characters
    
    streamData<<this->resCode<<";";
    
    streamData<<this->week<<";";
    //the precision needs to be changed
    //at least three numbers after the comma
    streamData.setf(std::ios_base::fixed, std::ios_base::floatfield);

    streamData<<std::setprecision(4)<<tow<<";";
    
    streamData.unsetf(std::ios_base::floatfield);//normalize the precision
    
    streamData<<this->weeklnit<<";";
    
    streamData<<this->towlnit<<";";
    
    //the precision needs to be changed
    //at least three numbers after the comma
    streamData.setf(std::ios_base::fixed, std::ios_base::floatfield);
    streamData<<std::setprecision(10)<<lat<<";";
    
    streamData<<std::setprecision(10)<<lon<<";";
    
    streamData<<std::setprecision(3)<<height<<";";
    
    streamData<<std::setprecision(3)<<ECEFX<<";";
    
    streamData<<std::setprecision(3)<<ECEFY<<";";
    
    streamData<<std::setprecision(3)<<ECEFZ<<";";
    
    
    for(i=0;i<3;i++)
    {
        streamData<<std::setprecision(3)<<this->b[i]<<";";
    }
    
    for(i=0;i<3;i++)
    {
        streamData<<std::setprecision(3)<<this->bStdDev[i]<<";";
    }
    
    for(i=0;i<3;i++)
    {
        streamData<<std::setprecision(3)<<this->vel[i]<<";";
    }
    
    for(i=0;i<3;i++)
    {
        streamData<<std::setprecision(3)<<this->velStdDev[i]<<";";
    }
    
    for(i=0;i<3;i++)
    {
        streamData<<std::setprecision(3)<<this->acc[i]<<";";
    }
    for(i=0;i<3;i++)
    {
        streamData<<std::setprecision(3)<<this->accStdDev[i]<<";";
    }
    
    for(i=0;i<3;i++)
    {
        streamData<<std::setprecision(3)<<this->att[i]<<";";
    }
    
    for(i=0;i<3;i++)
    {
        streamData<<std::setprecision(3)<<this->attStdDev[i]<<";";
    }
    
    streamData<<std::setprecision(3)<<this->accuracy<<";";
    
    for(i=0;i<5;i++)
    {
        streamData<<std::setprecision(3)<<this->timinginfo[i]<<";";
    }
   
    
    streamData<<std::setprecision(3)<<this->gnssReception<<";";
    
    streamData.unsetf(std::ios_base::floatfield);//normalize the precision
    

    //when the Complete format was chosen then the loop objects from the ubx-protocol have to be included
    if(iType==1)
    {
        //write number of satellites
        streamData<<(int)this->numSats<<";";
        
        //write the satellite loop in the stream
        pSatelliteLoop->writeInCsv(streamData);
        
        /*
        //write down amount in order to compare because normally always identical
        iNumSatellites=(int)this->numSats;
        iSizeVec = this->vecSatellite.size();
        
        //if number of satellites greater than one
        //then extract information from satellite vector
        if( iNumSatellites>0 && (iNumSatellites==iSizeVec))
        {
            //write Satellite attributes in File   
            /*
            for(i=0;i<iNumPotentialSat;i++)
            {
                if(i>=iAmountGPS && i<=MaxSatellitesGPS)
                {
                    pSatellite->resetSatellite();
                    pSatellite->writeInFile(streamData);
                }
                else if (i>=(iAmountEGNOS+iAmountGPS) &&
                        i<=(MaxSatellitesEGNOS+MaxSatellitesGPS))
                {
                    pSatellite->resetSatellite();
                    pSatellite->writeInFile(streamData);
                }
                else if (i>=(iAmountGLO+iAmountEGNOS+iAmountGPS) &&
                        i<=(MaxSatellitesGLONASS+MaxSatellitesEGNOS+MaxSatellitesGPS))
                {
                    pSatellite->resetSatellite();
                    pSatellite->writeInFile(streamData);
                }
                else if (i>=(iAmountGAL+iAmountGLO+iAmountEGNOS+iAmountGPS) &&
                        i<=(MaxSatellitesGALILEO+MaxSatellitesGLONASS+MaxSatellitesEGNOS+MaxSatellitesGPS))
                {
                    pSatellite->resetSatellite();
                    pSatellite->writeInFile(streamData);
                }
                else if (i>=(iAmountBEI+iAmountGLO+iAmountEGNOS+iAmountGPS) &&
                        i<=(MaxSatellitesBEIDOU+MaxSatellitesGLONASS+MaxSatellitesEGNOS+MaxSatellitesGPS))
                {
                    pSatellite->resetSatellite();
                    pSatellite->writeInFile(streamData);
                }
                else
                {
                    this->vecSatellite[i].writeInFile(streamData);
                }
            }
            */
            /*
            //*******************************************************
            
            if(arraybSatSys[3]==0)//if user choseBaisou instead of Galileo
            {
                iArrayMaxSatellites[3] = MaxSatellitesBEIDOU;
                iArrayAmountSat[3]= iAmountBEI;
            }
            
            //reset helping variables
            iMemory=0;
            currentSatSys=enumSatelliteSystems::Gps;
            for(j=0;j<4;j++)
            {
                
                if(arraybSatSys[j]==1||(arraybSatSys[j]==0 && j==3))//check if satellite system should be decoded 
                {
                    //Loop through columns with the maximum of satellites 
                    //in order to fill even the empty coloumns
                    for(i=0; i<iArrayMaxSatellites[j]; i++)
                    {
                        //check if vector does not contain anymore satellites
                        //of the j-th Satellite system 
                        //std::cout<<"Amount:"<<j<<" Sat:"<<iArrayAmountSat[j]<<std::endl;

                        if(i>=iArrayAmountSat[j])
                        {
                            streamData<<NAN<<";";
                            streamData<<NAN<<";";
                            streamData<<NAN<<";";
                            streamData<<NAN<<";";
                        }
                         // write down correct vector content of one satellite
                        else if( i<iArrayAmountSat[j] && 
                                (static_cast<int>(currentSatSys)==(int)vecSatellite[i+iMemory].getgnssId()) )
                        {
                            //std::cout<<"write Satellite"<<std::endl;
                            vecSatellite[i+iMemory].writeInFile(streamData);
                        }
                        else//cases where i<iArrayAmountSat[j] however vecSatellite[i+iMemory].getgnssId()+=1 
                        {
                            std::cout<<"WTF!!!!!!!!!!!!!!!!!!!!!!!!!!"<<std::endl;
                        }
                        //last ith element of a certain satellite group triggers
                        //the preservation of the pointer position
                        if(  i==(iArrayMaxSatellites[j]-1) && iArrayAmountSat[j]>0 )
                        {
                            iMemory+=iArrayAmountSat[j];
                            //std::cout<<"Memory:"<<iMemory<<std::endl;
                            ++currentSatSys;
                        }
                        //increases memory for 
                        //last ith element of a satellite system which does not appear in that epoch
                        else if(i==(iArrayMaxSatellites[j]-1) && iArrayAmountSat[j]==0)
                        {
                            //iMemory+=1;
                            ++currentSatSys;
                            //std::cout<<"Memory:"<<iMemory<<std::endl;
                        }
                    }
                }
                else if(arraybSatSys[j]==0 && j<3)
                {
                     iMemory+=iArrayAmountSat[j];
                }
            }
            
            /*
            if(arraybSatSys[0]==1)//Does the user want to decode GPS?
            {
                for(i=0;i<MaxSatellitesGPS;i++)
                {
                    if(i>=iAmountGPS && i<=MaxSatellitesGPS)
                    {
                        pSatellite->resetSatellite();
                        pSatellite->writeInFile(streamData);
                    }
                    else
                    {
                        this->vecSatellite[i].writeInFile(streamData);
                    }
                }
            }
            //*******************************************************
            if(arraybSatSys[1]==1)//Does the user want to decode EGNOS?
            {
                for(i=0;i<MaxSatellitesEGNOS;i++)
                {
                    if(i>=iAmountEGNOS && i<=MaxSatellitesEGNOS)
                    {
                        pSatellite->resetSatellite();
                        pSatellite->writeInFile(streamData);
                    }
                    else
                    {
                        this->vecSatellite[i].writeInFile(streamData);
                    }
                }
            }
            //*******************************************************
            if(arraybSatSys[2]==1)//Does the user want to decode GLONASS?
            {
                for(i=0;i<MaxSatellitesGLONASS;i++)
                {
                    if(i>=iAmountEGNOS && i<=MaxSatellitesGLONASS)
                    {
                        pSatellite->resetSatellite();
                        pSatellite->writeInFile(streamData);
                    }
                    else
                    {
                        this->vecSatellite[i].writeInFile(streamData);
                    }
                }
            }
            else if()
            if(arraybSatSys[3]==1)//Does the user want to decode EGNOS?
            {
                for(i=0;i<MaxSatellitesGALILEO;i++)
                {
                    if(i>=iAmountEGNOS && i<=MaxSatellitesGALILEO)
                    {
                        pSatellite->resetSatellite();
                        pSatellite->writeInFile(streamData);
                    }
                    else
                    {
                        this->vecSatellite[i].writeInFile(streamData);
                    }
                }
            }
            if(arraybSatSys[3]==0)//Does the user want to decode EGNOS?
            {
                for(i=0;i<MaxSatellitesBEIDOU;i++)
                {
                    if(i>=iAmountEGNOS && i<=MaxSatellitesBEIDOU)
                    {
                        pSatellite->resetSatellite();
                        pSatellite->writeInFile(streamData);
                    }
                    else
                    {
                        this->vecSatellite[i].writeInFile(streamData);
                    }
                }
            }
            
            */
        
        /*
        }
        else if(iNumSatellites > 0 && (iNumSatellites != iSizeVec) )
        {
            std::cout<<"something wrong!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!:"<<iSizeVec<<std::endl;
        }
        else if(iNumSatellites==0)
        {
            //std::cout<<"Fill loop__Vecotr:"<<iSizeVec<<"Potential SAT"<<iNumPotentialSat<<std::endl;
            for(i=0;i<iNumPotentialSat;i++)
            {
                streamData<<NAN<<";";
                streamData<<NAN<<";";
                streamData<<NAN<<";";
                streamData<<NAN<<";";
            }
        }
        */
        streamData<<(int)this->numRcv<<'\n';//std::endl;
    }
    else if(iType==0)
    {
        streamData<<(int)this->numSats<<'\n';
    }
}
void PAD::writeInKml(std::ofstream &streamData,int &iModus)
{
    //Parameters
    unsigned short usSolution=0;
    double dVelNorm;
    double dAccNorm;
    
    //unsigned short usFloatSolution=0;
    //unsigned short usLeastSquareSolution=0;
    std::string strResultCode="";
    
    if(iModus==0)//write Path coordinates
    {
        //std::fixed(streamData);
        streamData.setf(std::ios_base::fixed, std::ios_base::floatfield);
        streamData<<std::setprecision(10)<<lon<<",";
        streamData<<std::setprecision(10)<<lat<<",";
        streamData<<std::setprecision(3)<<height<<std::endl;
        //streamData<<std::defaultfloat;
        streamData.unsetf(std::ios_base::floatfield);
        //std::defaultfloat(streamData);
    }
    else if(iModus==1)//write Placemarkers
    {
        //check solution
        usSolution = (unsigned short)(resCode & 0b0001100000000000);//0b0001100000000000=6144
        //usFloatSolution=(unsigned short)(resCode &        0b0001000000000000);//0b0001000000000000=4096
        //usLeastSquareSolution=(unsigned short)(resCode &  0b0000100000000000);//0b0000100000000000=2048
        
        if(usSolution==6144)
        {
            strResultCode="RTK-Fixed Solution";
        }
        else if(usSolution==4096)
        {
            strResultCode="RTK-Float Solution";
        }
        else if(usSolution==2048)
        {
            strResultCode="RTK-Fixed Solution";
        }
        else 
        {
            std::cout<<"The Solution can not be identified.\n something is extremly wrong if this message appears!!!"<<std::endl;
        }
        //calculate norm variables
        dVelNorm = sqrt(pow(vel[0],2) + pow(vel[1],2) + pow(vel[2],2));
        dAccNorm = sqrt(pow(acc[0],2) + pow(acc[1],2) + pow(acc[2],2));
        
        //write into stream
        //std::defaultfloat(streamData);
        streamData.unsetf(std::ios_base::floatfield);
        //streamData.resetiosflags(std::ios::fixed)
        streamData << "<Placemark>" << std::endl;
        streamData << "<name></name>" << std::endl;
        streamData << "<visibility>1</visibility> " << std::endl;
        streamData << "<description><![CDATA[" << std::endl;
        streamData << "<strong>GNSS</strong>" << std::endl;
        streamData <<std::setprecision(10);
        streamData << "<br />Time-Of-Week [s]: " << tow << std::endl;
        streamData << "<br />RTK-State: " << strResultCode << std::endl;
        streamData << "<br />Height [m]: " << height << std::endl;
        streamData << "<br />Velocity [m/s]: " << dVelNorm << std::endl;
        streamData << "<br />Acceleration [m/sÂ²]: " << dAccNorm << std::endl;
        streamData << "<br />Heading [deg]: " << att[0] << std::endl;
        streamData << "<br />Pitch [deg]: " << att[1] << std::endl;
        streamData << "<br />Roll [deg]: " << att[2] << std::endl;
        streamData << "]]></description>" << std::endl;
        streamData << "<styleUrl>#bluePoint</styleUrl>" << std::endl;
        streamData << "<Point>" << std::endl;
        streamData << "<altitudeMode>absolute</altitudeMode>" << std::endl;
        //write the corresponding coordinates
        streamData << "<coordinates>";
        std::fixed(streamData);
        streamData <<std::setprecision(10);
        streamData <<lon<<",";//limit floating-point values on output operations
        streamData <<std::setprecision(10);
        streamData <<lat<<",";
        streamData <<std::setprecision(3);
        streamData <<height<< "</coordinates>" <<std::endl;
        //std::defaultfloat(streamData);
        streamData.unsetf(std::ios_base::floatfield);
        
        streamData << "</Point>" << std::endl;
        streamData << "</Placemark>" << std::endl;
        streamData << "" << std::endl;
    }
    else
    {
        std::cout<<"The Mode parameter can only be 0 or 1. \n Please refrain from using the function incorrectly"
                <<std::endl;
    }
}
void PAD::readOfFile(char** pc, bool *bSuccess)
{
    //Declare Parameters
    uint8_t uint8dummy=0;
    int i=0;
    
    int ilastSatSys=0;
    int icurrentSatSys=0;
    int inextSatSys=0;
    
    int iAmountSat=0;
    int iChoice=0;
    int iDummyVariable=0;
    unsigned char ucDummyVariable;
    short sDummyVariable=0;
    double dDummyVariable=0.0;
    
    //space for the satellite vector needs to be reserved
    //this->vecSatellite.reserve(30*sizeof(SATELLITE));
    
    *bSuccess=1;
    
    //feed Payload variables
    //identifier of System unsigned char

    this->id=CpyUnsignChar(pc);
    //std::cout<<(int)id<<std::endl;

    //result code bitfield, unsigned short
    this->resCode=CpyUnsignShort(pc);
        //std::cout<<resCode<<std::endl;
    
    //week number of current epoch, unsigned short
    this->week=CpyUnsignShort(pc);
        //std::cout<<week<<std::endl;
    //time of week, double
    this->tow=CpyDouble(pc);
        //std::cout<<tow<<std::endl;
    //weeklnit week number of epoch, unsigned short
    this->weeklnit=CpyUnsignShort(pc);
        //std::cout<<weeklnit<<std::endl;
    //time of week of the epoch when the sytem was started
    this->towlnit=CpyDouble(pc);
        //std::cout<<towlnit<<std::endl;
    //skip reserved short
    sDummyVariable=CpyShort(pc);
    //latitude, double
    this->lat=CpyDouble(pc);
    //longitude double
    this->lon=CpyDouble(pc);
    //height,double
    this->height=CpyDouble(pc);
    //ECEF-X, double
    this->ECEFX=CpyDouble(pc);
    //ECEF-Y, double
    this->ECEFY=CpyDouble(pc);
    //ECEF-Z, double
    this->ECEFZ=CpyDouble(pc);
    //baseline  Array of 3 doubles
    for(i=0;i<3;i++)
    {
        this->b[i]=CpyDouble(pc);
    }
    //bStdDev, Array of 3 doubles
    for(i=0;i<3;i++)
    {
        this->bStdDev[i]=CpyDouble(pc);
    }
    //velocity, Array of 3 doubles
    for(i=0;i<3;i++)
    {
        this->vel[i]=CpyDouble(pc);
    }
    //velocity standard deviation,Array of 3 doubles
    for(i=0;i<3;i++)
    {
        this->velStdDev[i]=CpyDouble(pc);
    }
    //acceleration, Array of 3 doubles
    for(i=0;i<3;i++)
    {
        this->acc[i]=CpyDouble(pc);
    }
    //acceleration standard deviation, Array of 3 doubles
    for(i=0;i<3;i++)
    {
        this->accStdDev[i]=CpyDouble(pc);
    }
    //attitude, Array of 3 doubles
    for(i=0;i<3;i++)
    {
        this->att[i]=CpyDouble(pc);
    }
    //attitude standard deviation, Array of 3 doubles
    for(i=0;i<3;i++)
    {
        this->attStdDev[i]=CpyDouble(pc);
    }
    
    //accuracy
    this->accuracy=CpyDouble(pc);
    
    //skip reserved double
    dDummyVariable=CpyDouble(pc);//just to make the pointer jump the reserved double
    
    //timing info, Array of 5 doubles
    for(i=0;i<5;i++)
    {
        this->timinginfo[i]=CpyDouble(pc);
    }
    
    //skip reserved Array of 5 doubles
    for(i=0;i<5;i++)
    {//just to make the pointer jump the reserved doubles
        dDummyVariable=CpyDouble(pc);
    }
    
    //GNSS signal reception value between 0 and 20, double
    this->gnssReception=CpyDouble(pc);
    
    //Read the Satellites
    //Number of Satellites, unsigned char
    this->numSats=CpyUnsignChar(pc);
    
    
    iAmountSat=(int)this->numSats;
    
    //std::cout<<"Satellite Amount before: "<<iAmountSat<<std::endl;
    
    this->pSatelliteLoop->setiAmountSat(iAmountSat);
    
    //fill the Satellite vector
    if(iAmountSat>0)
    {
        //std::cout<<"Satellite Amount : "<<iAmountSat<<std::endl;
        this->pSatelliteLoop->readOfFile(&pc);
        /*
        iAmountGPS=0;
        iAmountEGNOS=0;
        iAmountGLO=0;
        iAmountGAL=0;
        iAmountBEI=0;
        //Read all sytellite related information and save the amount of each satellite system.
        for(i=0;i<iAmountSat;i++)
        {
            //Read Data in object pointer
            this->pSatellite->readOfFile(&pc);
            
            //Set GNSS ID
            //if(i!=0)
            //{
                ilastSatSys=((int)vecSatellite.back().getgnssId());
            //}
            icurrentSatSys=static_cast<int>(currentSatSys);
            inextSatSys=((int)pSatellite->getgnssId());
            
            //enter the correct satellite into the corresponding column
            if(i==0)//start
            {
                //static_cast<int>(currentSatSys)=((int)pSatellite->getgnssId());
                assignSatSys(currentSatSys, inextSatSys);
                //std::cout<<"Test_first: current status: "<<static_cast<int>(currentSatSys)<<std::endl;
                completeAmountListBeginning(currentSatSys);
            }
            else if( 0<i && i<(iAmountSat-1) &&
                    ilastSatSys == icurrentSatSys && inextSatSys != icurrentSatSys )//middle
            {
                //save amounts of every satellite system
                assignAmountGNSS(currentSatSys, i);
                
                assignSatSys(currentSatSys, inextSatSys);
            }
            else if(i==(iAmountSat-1))//last satellite
            {
                assignSatSys(thisSatSys, inextSatSys);
                if(currentSatSys==thisSatSys)
                {
                    assignAmountGNSS(currentSatSys, i);
                    completeAmountListEnding(currentSatSys);
                }
                else if(currentSatSys!=thisSatSys)
                {
                    assignAmountGNSS(currentSatSys, i);
                    assignAmountGNSS(thisSatSys, (i+1) );
                    completeAmountListEnding(thisSatSys);
                }
            }

            else
            {
                assignSatSys(currentSatSys, (int)pSatellite->getgnssId());
                std::cout<<"Test_third: current status: "<<static_cast<int>(currentSatSys)<<std::endl;
            }
            
            
            
            std::cout<<"GNSS ID:"<<std::endl;
            std::cin>>uint8dummy;
            this->pSatellite->gnssId=(unsigned char)uint8dummy;
            
            std::cout<<"Space Vehicle ID:"<<std::endl;
            std::cin>>uint8dummy;
            this->pSatellite->svId=(unsigned char)uint8dummy;
            
            std::cout<<"Elevation:"<<std::endl;
            std::cin>>this->pSatellite->elev;
            
            std::cout<<"Azimuth:"<<std::endl;
            std::cin>>this->pSatellite->azim;
            
            std::cout<<"GNSS ID:"<<(int)this->pSatellite->gnssId<<std::endl;
            std::cout<<"Space Vehicle ID:"<<(int)this->pSatellite->svId<<std::endl;
            std::cout<<"Elevation:"<<this->pSatellite->elev<<std::endl;
            std::cout<<"Azimuth:"<<this->pSatellite->azim<<std::endl;
            
            
            //include new satellite object in satellite vector
            this->fillVector();
            //Reset Satellite pointer, placeholder
            this->pSatellite->resetSatellite();

        }
        */
        
        
        //!!!!!!!!!!!!!!!!!!!!!!!!!!--DEVELOPMENT TOOL--!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        //*bSuccess=0;//just activate if you want to stop after 
        //the first line with satellite attributes
    }
    
    this->numRcv=CpyUnsignChar(pc);
    
    //ONLY FOR DEVELOPMENT PURPOSES!!!!!
    //If everything went well then bsuccess=TRUE 
    //however if loop to stop after first line with satellite attributes
    //ONLY FOR DEVELOPMENT PURPOSES!!!!!
    if(*bSuccess==0)
    {
        *bSuccess=0;//ONLY FOR DEVELOPMENT PURPOSES!!!!!
    }
    else
    {
        *bSuccess=1;
    }
}

int PAD::getVectorSize()
{
    int i=0;
    i=this->pSatelliteLoop->getTotalVectorSize();
    return i;
}

void PAD::clearVector()
{
    pSatelliteLoop->clearAllVectors();
}

unsigned short PAD::getResultCode()
{
    return resCode;
}

void PAD::chosenSatSys(bool &refbGPS, bool &refbEGNOS, bool &refbGLONASS,bool &refbGALILEO)
{
    arraybSatSys[0]=refbGPS;
    arraybSatSys[1]=refbEGNOS;
    arraybSatSys[2]=refbGLONASS;
    arraybSatSys[3]=refbGALILEO;
    
    iNumPotentialSat=((int)refbGPS)*MaxSatellitesGPS;
    iNumPotentialSat+=((int)refbEGNOS)*MaxSatellitesEGNOS;
    iNumPotentialSat+=((int)refbGLONASS)*MaxSatellitesGLONASS;
    if(refbGALILEO==1)
    {
        iNumPotentialSat+=((int)refbGALILEO)*MaxSatellitesGALILEO;
    }
    else
    {
        iNumPotentialSat+=((int)refbGALILEO)*MaxSatellitesBEIDOU;
    }
    //Set the Parameters of the Satellite loop object
    pSatelliteLoop->setiNumPotentialSat(iNumPotentialSat);
    pSatelliteLoop->setArraybSatSys(arraybSatSys);
}
void PAD::resetPointers()
{
    pSatelliteLoop->resetPointers();
    delete pSatelliteLoop;
}
/*
void PAD::reserveVector()
{
    vecSatellite.reserve(iNumPotentialSat*sizeof(SATELLITE));
}
*/

/*
 * 
void PAD::fillVector()
{
    vecSatellite.push_back(*pSatellite);
    //vecSatellite.push_back(satellitePlaceholder);
}
void PAD::completeAmountListBeginning(enumSatelliteSystems &SatSys)
{
    //if(static_cast<int>(SatSys)==1)
    
    switch(SatSys)
    {
        case enumSatelliteSystems::Gps:
        {
            break;
        }
        case enumSatelliteSystems::Egnos:
        { 
            iAmountGPS=0;
            break;
        }
        case enumSatelliteSystems::Glonass:
        {
            iAmountGPS=0;
            iAmountEGNOS=0;
            break;
        }
        case enumSatelliteSystems::Galileo:
        {
            iAmountGPS=0;
            iAmountEGNOS=0;
            iAmountGLO=0;
            break;
        }
        case enumSatelliteSystems::Beidou:
        {
            iAmountGPS=0;
            iAmountEGNOS=0;
            iAmountGLO=0;
            iAmountGAL=0;
            break;
        }
        default:
        {
            std::cout<<"Satellite no recognized!!! The satellite system exceeds the known knowledge!"<<std::endl;
            break;
        }
    }
}
void PAD::completeAmountListEnding(enumSatelliteSystems &SatSys)
{
    switch(SatSys)
    {
        case enumSatelliteSystems::Gps:
        {
            iAmountEGNOS=0;
            iAmountGLO=0;
            iAmountGAL=0;
            iAmountBEI=0;
            break;
        }
        case enumSatelliteSystems::Egnos:
        { 
            iAmountGLO=0;
            iAmountGAL=0;
            iAmountBEI=0;
            break;
        }
        case enumSatelliteSystems::Glonass:
        {
            iAmountGAL=0;
            iAmountBEI=0;
            break;
        }
        case enumSatelliteSystems::Galileo:
        {
            iAmountBEI=0;
            break;
        }
        case enumSatelliteSystems::Beidou:
        {
            iAmountGAL=0;
            break;
        }
        default:
        {
            std::cout<<"Satellite no recognized!!! The satellite system exceeds the known knowledge!"<<std::endl;
            break;
        }
    }
}
void PAD::assignSatSys(enumSatelliteSystems &SatSys,int iconstexpres)
{
    switch(iconstexpres)
    {
        case 1:
        {
            SatSys=enumSatelliteSystems::Gps;
            break;
        }
        case 2:
        { 
            SatSys=enumSatelliteSystems::Egnos;
            break;
        }
        case 4:
        {
            SatSys=enumSatelliteSystems::Glonass;
            break;
        }
        case 8:
        {
            SatSys=enumSatelliteSystems::Galileo;
            break;
        }
        case 32:
        {
            SatSys=enumSatelliteSystems::Beidou;
            break;
        }
        default:
        {
            std::cout<<"No Satellite assignable"<<std::endl;
            break;
        }
    }
}
void PAD::assignAmountGNSS(enumSatelliteSystems &SatSys, int i)
{
    if(SatSys==enumSatelliteSystems::Gps)
    {
        iAmountGPS=i;
        //std::cout<<"GPS:        "<<iAmountGPS<<std::endl;
    }
    else if(SatSys==enumSatelliteSystems::Egnos)
    {
        iAmountEGNOS=i-iAmountGPS;
        //std::cout<<"EGNOS:      "<<iAmountEGNOS<<std::endl;
    }
    else if(SatSys==enumSatelliteSystems::Glonass)
    {
        iAmountGLO=i-iAmountGPS-iAmountEGNOS;
        //std::cout<<"GLONASS:    "<<iAmountGLO<<std::endl;
    }
    else if(SatSys==enumSatelliteSystems::Galileo)
    {
        iAmountGAL=i-iAmountGPS-iAmountEGNOS-iAmountGLO;
        //std::cout<<"GALILEO:    "<<iAmountGAL<<std::endl;
    }
    else if(SatSys==enumSatelliteSystems::Beidou)
    {
        iAmountBEI=i-iAmountGPS-iAmountEGNOS-iAmountGLO;
    }
    else
    {
        std::cout<<"Not recognizable satellite!!!!!!!!!!!!!"<<std::endl;
    }
}

*/