/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   SATELLITE.h
 * Author: Maxi
 *
 * Created on 14. November 2018, 18:16
 */

#ifndef SATELLITE_H
#define SATELLITE_H

#include <fstream>
#include "CopyFunc.h"
#include <iostream>//for debugging
#include <iomanip>//std::setprecision
#include <ratio>
#include <cmath>


class SATELLITE {

//friend class PAD;
    
public:
    SATELLITE();
    SATELLITE(const SATELLITE& orig);
    virtual ~SATELLITE();
    void writeInFile(std::ofstream &refOutputData);
    void readOfFile(char**** pcInputData);
    void resetSatellite();
    void viewData();
    unsigned char getgnssId();
    unsigned char getSvId();
private:
    // Spave vehicle and GNSS id
    unsigned char gnssId;
    unsigned char svId;
    // Satellite position
    double elev;
    double azim;
};

#endif /* SATELLITE_H */

